unit DFileShpFrm;

{
Main form GETS
      FileName := SaveDialog.FileName;
      FilePath := ExtractFilePath(SaveDialog.FileName);
       does its own procedure SaveDXF;
 calls DFileShpFrm

DFileShpFrm
  to GET INFORMATION and PASS on to actual procedures
  Object type
  Shp Layer
    Save &All   OR Save &Layer button
                  SaveSHP;
        procedure SaveDLG;
        procedure LoadSHP;
  CALLS SaveShpFile AND  SaveDatabase in ALLShpSaver UNIT


ALLShpSaver UNIT contains ALL DATA type declarations and:
procedure SaveShpFile(LayerToSave:Integer;FileName:String);
procedure SaveShpDXFFile(LayerToSave:Integer;FileName:String);
Function LoadDatabase(WhichLayer:Integer):Boolean;
Function SaveDatabase(WhichLayer:Integer):Boolean;
function RunTimeDbCreate(
  const DatabaseName, SessionName: string): TDatabase;
}

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, math, Db, Dbf;

type
  TShpSaveForm = class(TForm)
    ProgressBar1: TProgressBar;
    SsHelpBtn: TBitBtn;
    SaveLayerBtn: TSpeedButton;
    ObjectTypeRG: TRadioGroup;
    Label1: TLabel;
    ExitBtn: TBitBtn;
    DDegreeRG: TRadioGroup;
    DataSource1: TDataSource;
    SSLayersRG: TRadioGroup;
    dbTable: TDbf;
    AboutTdbfBtn: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SsHelpBtnClick(Sender: TObject);
    procedure SaveLayerBtnClick(Sender: TObject);
    procedure MakeShipSHP;
    procedure ExitBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AboutTdbfBtnClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  ShpSaveForm: TShpSaveForm;

implementation

{$R *.DFM}

uses DGlobalsUnit, AllShapeLoaderFrm,
      buzGlobal, buzGCTP, buzDatum, AllDbAboutFrm;

procedure TShpSaveForm.FormCreate(Sender: TObject);
begin{ShpSaveForm}
  left := ShpSetFormX;
  top := ShpSetFormY;
end;

procedure TShpSaveForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin{ShpSaveForm}
  ShpSetFormX := ShpSaveForm.left;
  ShpSetFormY := ShpSaveForm.top;
  DoSaver;
end;

procedure TShpSaveForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TShpSaveForm.AboutTdbfBtnClick(Sender: TObject);
begin
  allDbAboutForm := TallDbAboutForm.Create(Application);
  allDbAboutForm.ShowModal;
  allDbAboutForm.Free;
end;

procedure TShpSaveForm.SsHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8000);
end;

procedure TShpSaveForm.FormShow(Sender: TObject);
begin
  Label1.Caption:=FileName;
end;

procedure TShpSaveForm.SaveLayerBtnClick(Sender: TObject);
begin {ShpSaveForm     ObjectTypeRG}
  ShpSaveForm.Cursor:=crHourGlass;
  Application.ProcessMessages;  
  MakeShipSHP;
  ShpSaveForm.Cursor:=crDefault;
  Application.ProcessMessages;
  ShpSaveForm.Close;
end;

{Process Tracer data into a Shape file structure}
procedure TShpSaveForm.MakeShipSHP;
var
  OutUnits:Boolean;
  ShapeType, PointCount, IslandCount,i: Integer;
  NumParts, NumPoints,   ShapeNumber: integer;
  ObjectType, SSLayer,  AttListCount,ShapeListCount,
  Counter: Integer;
  REALLOCATIONx,  REALLOCATIONy,
  dXMINtF, dYMINtF, dXMAXtF, dYMAXtF:Double;
  dXMINt, dYMINt, dXMAXt, dYMAXt:Double;
  DXtemp,DYtemp, DXdtemp,DYdtemp:Double;
{  dbTable: TTable;}
begin
  if bHeaderSet then
  begin
    Application.ProcessMessages;
  {Get data info}
    ProgressBar1.Position:=0;
    If DDegreeRG.Itemindex=1 then OutUnits:=True else
     OutUnits:=False;{Decimal Degrees}

    Case ObjectTypeRG.Itemindex of
    0:if (PointList.Count > 0) then Shapetype:=1 else
      begin
        DoMessages(205);
        exit;
      end;
    1:if (LineList.Count > 0) then Shapetype:=3 else
      begin
        DoMessages(206);
        exit;
      end;
    2:if (AreaList.Count > 0) then Shapetype:=5 else
      begin
        DoMessages(207);
        exit;
      end;
      else Shapetype:=1;
    end;

    AttListCount:=0;
    ObjectType:=ObjectTypeRG.Itemindex;
    SSLayer:=SSLayersRG.Itemindex;
  Inc(LayersLoaded);
  CurrentLayer:=LayersLoaded;
  SetLength(LayA,LayersLoaded+1);
  {Get Base .dbf and copy its stuff}
(*
  If ( not (fileexists(ExtractFilePath(ParamStr(0)) +'tracershp.dbf'))) then
  begin
    DoMessages(30115);
  exit;
  end;
    DemTable.Active:=False;
    DemTable.TableName:=ExtractFilePath(ParamStr(0)) +'tracershp.dbf';
    DemTable.Active:=True;
    DemTable.First;
    LayA[CurrentLayer].AttributesN:=DemTable.FieldDefs.Count;
    SetLength(LayA[CurrentLayer].AttType,
            LayA[CurrentLayer].AttributesN);
  for i:= 0 to DemTable.FieldDefs.Count - 1 do
  begin
    LayA[CurrentLayer].AttType[i].FieldNo:=
        DemTable.FieldDefs[i].FieldNo;
    LayA[CurrentLayer].AttType[i].Displayname:=
        DemTable.FieldDefs[i].Name;
    LayA[CurrentLayer].AttType[i].DataType:=
        DemTable.FieldDefs[i].DataType;
    LayA[CurrentLayer].AttType[i].Size:=
        DemTable.FieldDefs[i].Size;
    LayA[CurrentLayer].AttType[i].Precision:=
        DemTable.FieldDefs[i].Precision;
    LayA[CurrentLayer].AttType[i].Required:=
        DemTable.FieldDefs[i].Required;
  end;
    DemTable.Active:=False;
    DemTable.TableName:='';
    {Make a database table}
    dbTable:=TTable.Create(ShpSaveForm);
    with dbTable do
    begin
      dbTable.Active:=False;
      DatabaseName := DemTable.DatabaseName;
      TableType := ttDBase;
      TableName := ChangeFileExt(ExtractFileName(FileName), '.dbf');
      with FieldDefs do
      begin
        Clear;
        for i:= 0 to LayA[CurrentLayer].AttributesN - 1 do
        begin
          with AddFieldDef do
          begin
            FieldNo:=LayA[CurrentLayer].AttType[i].FieldNo;
            Name := LayA[CurrentLayer].AttType[i].Displayname;
            DataType := LayA[CurrentLayer].AttType[i].DataType;
            Size:=LayA[CurrentLayer].AttType[i].Size ;
            Precision:=LayA[CurrentLayer].AttType[i].Precision;
            Required:=LayA[CurrentLayer].AttType[i].Required;
          end;
        end;
      End;
     CreateTable;
     dbTable.Active := True;
    end;
*)
  With dbTable do begin
    Close;
    FilePath := ExtractFilePath(FileName);
    TableName := ChangeFileExt(ExtractFileName(FileName), '.dbf');
    TableLevel:=3;
    with FieldDefs do begin
      Clear;
      {Add('Field1',ftString,10,False);}
      Add('ITEM',ftInteger,0,False);
      Add('MAJOR',ftInteger,0,False);
      Add('MINOR',ftInteger,0,False);
      Add('DESC',ftInteger,0,False);
      Add('PMAJOR',ftInteger,0,False);
      Add('PMINOR',ftInteger,0,False);
     { with Dbf1.AddFieldDef do begin
        FieldName := 'Field2';
        NativeFieldType := 'I';
        Size := 10;
        Precision := 3;
      end;}
    end;
    CreateTable;
    Open;
  end;
(*
    With Table1 do
    begin
      Table1.Active:=False;
      DatabaseName := ExtractFilePath(FileName);
      TableName := ChangeFileExt(ExtractFileName(FileName), '.dbf');
      with FieldDefs do begin
        Clear;
        with AddFieldDef do begin
          Name := 'ITEM';
          DataType := ftInteger;
          Required := True;
        end;
        with AddFieldDef do begin
          Name := 'MAJOR';
          DataType := ftInteger;
          Required := True;
        end;
        with AddFieldDef do begin
          Name := 'MINOR';
          DataType := ftInteger;
          Required := True;
        end;
        with AddFieldDef do begin
          Name := 'DESC';
          DataType := ftInteger;
          Required := True;
        end;
        with AddFieldDef do begin
          Name := 'PMAJOR';
          DataType := ftInteger;
          Required := True;
        end;
        with AddFieldDef do begin
          Name := 'PMINOR';
          DataType := ftInteger;
          Required := True;
        end;
      end;
      {with Table1.IndexDefs.AddIndexDef do
      begin
        Name := 'DBF';
        Fields := 'ITEM';
        Options := [];
      end;}
      CreateTable;
      Table1.Active := True;{Open;}
    end;
*)
    if (AttriList.Count > 0) then
    begin
      for Counter := 0 to (AttriList.Count - 1) do
      begin
        ProgressBar1.Position:=round(Counter/AttriList.Count )*50;
        Application.ProcessMessages;
        aAttri := AttriList.Items[Counter];
        axAttri.Layer := aAttri^.Layer;
        axAttri.ObjectType := aAttri^.ObjectType;
        axAttri.Count := aAttri^.Count;
        axAttri.Major := aAttri^.Major;
        axAttri.Minor := aAttri^.Minor;
        axAttri.Descriptive := aAttri^.Descriptive;
        axAttri.ParameterMajor := aAttri^.ParameterMajor;
        axAttri.ParameterMinor := aAttri^.ParameterMinor;
        If ((ObjectType = axAttri.ObjectType)
           and (SSLayer = axAttri.Layer)) then
        begin  {Object type is per att layer}
          inc(AttListCount);
           dbTable.Append;
           dbTable.Fields[0].Value:= AttListCount;
           dbTable.Fields[1].Value:= axAttri.Major;
           dbTable.Fields[2].Value:= axAttri.Minor;
           dbTable.Fields[3].Value:= axAttri.Descriptive;
           dbTable.Fields[4].Value:= axAttri.ParameterMajor;
           dbTable.Fields[5].Value:= axAttri.ParameterMinor;
            dbTable.Post;
          {dbTable.AppendRecord([AttListCount,
          axAttri.Major,axAttri.Minor,axAttri.Descriptive,
          axAttri.ParameterMajor,axAttri.ParameterMinor]);}
          {dbTable.AppendRecord([inttostr(AttListCount),
          inttostr(axAttri.Major),inttostr(axAttri.Minor),inttostr(axAttri.Descriptive),
          inttostr(axAttri.ParameterMajor),inttostr(axAttri.ParameterMinor)]);}
        end;
      end;
    end else
    begin
      DoMessages(30114);{('NO Attributes');}
      dbTable.Active:=False;
      dbTable.TableName:='';
      exit;
    End;
    dbTable.Active:=False;
    dbTable.TableName:='';
    {dbTable.Free;}
    If (AttListCount=0) then begin
      DoMessages(30114);{('No Attributes found for Object Layer');}
        LayersLoaded:=0;
        SetLength(LayA,0);
        ProgressBar1.Position:=0;
      exit;
    End;
    {Inc(LayersLoaded);
    CurrentLayer:=LayersLoaded;
    SetLength(LayA,LayersLoaded+1);}{Trash the Zero layer in array}
    ShapeNumber:=0;
    ShapeListCount:=0;
    NumPoints:=0;
    Numparts:=1;{always for this, no linked lines or interior polys}
    PointCount := 0;
    IslandCount := 0;
    {5.0 x 10^324 .. 1.7 x 10^308}
    dXMINt:=1.7 * power(10,308);
    dYMINt:=1.7 * power(10,308);
    dXMAXt:=-1.7 * power(10,308);
    dYMAXt:=-1.7 * power(10,308);
    dXMINtF:=1.7 * power(10,308);
    dYMINtF:=1.7 * power(10,308);
    dXMAXtF:=-1.7 * power(10,308);
    dYMAXtF:=-1.7 * power(10,308);
    Case Shapetype of
    1:begin {Points}
        LayA[CurrentLayer].ShpType:=Shapetype;
        for Counter := 0 to (PointList.Count - 1) do begin
          ProgressBar1.Position:=50+(round(Counter/AreaList.Count )*50);
          Application.ProcessMessages;
          aDrawingPnt := PointList.Items[Counter];
          axDrawingPnt.X := aDrawingPnt^.X;
          axDrawingPnt.Y := aDrawingPnt^.Y;
          axDrawingPnt.PX := aDrawingPnt^.PX;
          axDrawingPnt.PY := aDrawingPnt^.PY;
          axDrawingPnt.PointType := aDrawingPnt^.PointType;
          axDrawingPnt.Layer := aDrawingPnt^.Layer;
          axDrawingPnt.color := aDrawingPnt^.color;
          If (SSLayer = axDrawingPnt.Layer) then
          begin
            inc(NumPoints);
            inc(ShapeListCount);
            inc(ShapeNumber);
            Setlength(LayA[CurrentLayer].LyrShp,ShapeNumber+1);
            LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
            {CONVERSION to REAL LOCATION}
            REALLOCATIONx:=((axDrawingPnt.X-LowerDigiLocoX) * XScaleRatio)+XOrigin;
            REALLOCATIONy:=((axDrawingPnt.Y-LowerDigiLocoY)* XScaleRatio)+YOrigin;
            If OutUnits then
            begin
              DXdtemp:=REALLOCATIONx;
              DYdtemp:=REALLOCATIONy;
              dXTemp:=DXdtemp*UnitFactorLL;
              dYTemp:=DYdtemp*UnitFactorLL;
              DoLLtoXY( dXTemp,dYTemp,
                        DXdtemp,DYdtemp);
              DXtemp:=ToDDegreeFactorLL*dXdTemp;
              DYtemp:=ToDDegreeFactorLL*dYdTemp;
              REALLOCATIONx:=DXtemp;
              REALLOCATIONy:=DYtemp;
            end;

            dXMINt := REALLOCATIONx;
            if REALLOCATIONx<dXMINtF then dXMINtF := REALLOCATIONx;
            dYMINt := REALLOCATIONy;
            if REALLOCATIONy<dYMINtF then dYMINtF := REALLOCATIONy;
            dXMAXt := REALLOCATIONx;
            if REALLOCATIONx>dXMAXtF then dXMAXtF := REALLOCATIONx;
            dYMAXt := axDrawingAreaPnt.Y;
            if REALLOCATIONy>dYMAXtF then dYMAXtF := REALLOCATIONy;

            LayA[CurrentLayer].LyrShp[ShapeNumber].ShpType:=ShapeType;
            LayA[CurrentLayer].LyrShp[ShapeNumber].ShapeIDN:=ShapeNumber;
            LayA[CurrentLayer].LyrShp[ShapeNumber].XMin:= dXMINt;
            LayA[CurrentLayer].LyrShp[ShapeNumber].YMin:= dYMINt;
            LayA[CurrentLayer].LyrShp[ShapeNumber].XMax:= dXMAXt;
            LayA[CurrentLayer].LyrShp[ShapeNumber].YMax:= dYMAXt;
          end;
          LayA[CurrentLayer].LayerColor:=
               RGB(Random(255),Random(255),Random(255));
          LayA[CurrentLayer].ShapeN:=ShapeNumber;{NumShape;}
          LayA[CurrentLayer].TotalPnts:=PointCount;
          LayA[CurrentLayer].IslandsN:=0;
          LayA[CurrentLayer].XMin:= dXMINtF;
          LayA[CurrentLayer].YMin:= dYMINtF;
          LayA[CurrentLayer].XMax:= dXMAXtF;
          LayA[CurrentLayer].YMax:= dYMAXtF;
          LayA[CurrentLayer].ZMin:= 0;
          LayA[CurrentLayer].ZMax:= 0;
          LayA[CurrentLayer].MMin:= 0;
          LayA[CurrentLayer].MMax:= 0;
        end;{point count}
        If (AttListCount<>ShapeListCount) then DoMessages(204)
           else   ShapeLoaderForm.SaveShpFile(CurrentLayer,FileName);
      end;{points}
    3:Begin{Lines}
        LayA[CurrentLayer].ShpType:=Shapetype;
        for Counter := 0 to (LineList.Count - 1) do begin
          ProgressBar1.Position:=50+(round(Counter/AreaList.Count )*50);
          Application.ProcessMessages;
          aDrawingLnPnt := LineList.Items[Counter];
          axDrawingLnPnt.Line := aDrawingLnPnt^.Line;
          axDrawingLnPnt.X := aDrawingLnPnt^.X;
          axDrawingLnPnt.Y := aDrawingLnPnt^.Y;
          axDrawingLnPnt.PX := aDrawingLnPnt^.PX;
          axDrawingLnPnt.PY := aDrawingLnPnt^.PY;
          axDrawingLnPnt.Layer := aDrawingLnPnt^.Layer;
          axDrawingLnPnt.color := aDrawingLnPnt^.color;
          axDrawingLnPnt.LineType := aDrawingLnPnt^.LineType;
          If (SSLayer = axDrawingLnPnt.Layer) then
          begin
            If (ShapeListCount = axDrawingLnPnt.Line) then
            begin {another point}
              inc(NumPoints);
              LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
              inc(PointCount);{:=PointCount+NumPoints;}{Total points for File}
              LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[Numparts]:=NumPoints;
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[Numparts].PA,NumPoints+1);
              {CONVERSION to REAL LOCATION}
              REALLOCATIONx:=((axDrawingLnPnt.X-LowerDigiLocoX) * XScaleRatio)+XOrigin;
              REALLOCATIONy:=((axDrawingLnPnt.Y-LowerDigiLocoY)* XScaleRatio)+YOrigin;
              If OutUnits then
              begin
                DXdtemp:=REALLOCATIONx;
                DYdtemp:=REALLOCATIONy;
                dXTemp:=DXdtemp*UnitFactorLL;
                dYTemp:=DYdtemp*UnitFactorLL;
                DoLLtoXY( dXTemp,dYTemp,
                          DXdtemp,DYdtemp);
                DXtemp:=ToDDegreeFactorLL*dXdTemp;
                DYtemp:=ToDDegreeFactorLL*dYdTemp;
                REALLOCATIONx:=DXtemp;
                REALLOCATIONy:=DYtemp;
              end;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Xd:=
              REALLOCATIONx ;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Yd:=
              REALLOCATIONy;
              if REALLOCATIONx<dXMINt then dXMINt := REALLOCATIONx;
              if REALLOCATIONx<dXMINtF then dXMINtF := REALLOCATIONx;
              if REALLOCATIONy<dYMINt then dYMINt := REALLOCATIONy;
              if REALLOCATIONy<dYMINtF then dYMINtF := REALLOCATIONy;
              if REALLOCATIONx>dXMAXt then dXMAXt := REALLOCATIONx;
              if REALLOCATIONx>dXMAXtF then dXMAXtF := REALLOCATIONx;
              if REALLOCATIONy>dYMAXt then dYMAXt := REALLOCATIONy;
              if REALLOCATIONy>dYMAXtF then dYMAXtF := REALLOCATIONy;
              LayA[CurrentLayer].LyrShp[ShapeNumber].XMin:= dXMINt;
              LayA[CurrentLayer].LyrShp[ShapeNumber].YMin:= dYMINt;
              LayA[CurrentLayer].LyrShp[ShapeNumber].XMax:= dXMAXt;
              LayA[CurrentLayer].LyrShp[ShapeNumber].YMax:= dYMAXt;
            end else
            begin {first point in line}
              inc(ShapeListCount);
              inc(ShapeNumber);
              {NumShape:=SwapShapeInteger(ICOIn);}{Store total for later}
              Setlength(LayA[CurrentLayer].LyrShp,ShapeNumber+1);
              LayA[CurrentLayer].LyrShp[ShapeNumber].ShpType:=ShapeType;
              LayA[CurrentLayer].LyrShp[ShapeNumber].ShapeIDN:=ShapeNumber;

              LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN:=Numparts;
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PPA,Numparts+1);
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA,Numparts+1);

              NumPoints:=0;{reset for rest of object}
              dXMINt:=1.7 * power(10,308);
              dYMINt:=1.7 * power(10,308);
              dXMAXt:=-1.7 * power(10,308);
              dYMAXt:=-1.7 * power(10,308);
              {input First point}
              inc(NumPoints);
              LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
              inc(PointCount);{:=PointCount+NumPoints;}{Total points for File}
              LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[Numparts]:=NumPoints;
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[Numparts].PA,NumPoints+1);
              {CONVERSION to REAL LOCATION}
              REALLOCATIONx:=((axDrawingLnPnt.X-LowerDigiLocoX) * XScaleRatio)+XOrigin;
              REALLOCATIONy:=((axDrawingLnPnt.Y-LowerDigiLocoY)* XScaleRatio)+YOrigin;
              If OutUnits then
              begin
                DXdtemp:=REALLOCATIONx;
                DYdtemp:=REALLOCATIONy;
                dXTemp:=DXdtemp*UnitFactorLL;
                dYTemp:=DYdtemp*UnitFactorLL;
                DoLLtoXY( dXTemp,dYTemp,
                          DXdtemp,DYdtemp);
                DXtemp:=ToDDegreeFactorLL*dXdTemp;
                DYtemp:=ToDDegreeFactorLL*dYdTemp;
                REALLOCATIONx:=DXtemp;
                REALLOCATIONy:=DYtemp;
              end;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Xd:=
              REALLOCATIONx ;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Yd:=
              REALLOCATIONy;
            end;
          end;
          LayA[CurrentLayer].LayerColor:=
            RGB(Random(255),Random(255),Random(255));
          LayA[CurrentLayer].ShapeN:=ShapeNumber;{NumShape;}
          LayA[CurrentLayer].TotalPnts:=PointCount;
          LayA[CurrentLayer].IslandsN:=0;
          LayA[CurrentLayer].XMin:= dXMINtF;
          LayA[CurrentLayer].YMin:= dYMINtF;
          LayA[CurrentLayer].XMax:= dXMAXtF;
          LayA[CurrentLayer].YMax:= dYMAXtF;
          LayA[CurrentLayer].ZMin:= 0;
          LayA[CurrentLayer].ZMax:= 0;
          LayA[CurrentLayer].MMin:= 0;
          LayA[CurrentLayer].MMax:= 0;
        end;{lines count}
        If (AttListCount<>ShapeListCount) then DoMessages(204)
         else   ShapeLoaderForm.SaveShpFile(CurrentLayer,FileName);
      end;{lines}
    5:Begin{Polys}
        LayA[CurrentLayer].ShpType:=Shapetype;
        for Counter := 0 to (AreaList.Count - 1) do
        begin
          ProgressBar1.Position:=50+(round(Counter/AreaList.Count )*50);
          Application.ProcessMessages;
          aDrawingAreaPnt := AreaList.Items[Counter];
          axDrawingAreaPnt.Area := aDrawingAreaPnt^.Area;
          axDrawingAreaPnt.X := aDrawingAreaPnt^.X;
          axDrawingAreaPnt.Y := aDrawingAreaPnt^.Y;
          axDrawingAreaPnt.PX := aDrawingAreaPnt^.PX;
          axDrawingAreaPnt.PY := aDrawingAreaPnt^.PY;
          axDrawingAreaPnt.Layer := aDrawingAreaPnt^.Layer;
          axDrawingAreaPnt.Pencolor := aDrawingAreaPnt^.Pencolor;
          axDrawingAreaPnt.Brushcolor := aDrawingAreaPnt^.Brushcolor;
          axDrawingAreaPnt.PolyType := aDrawingAreaPnt^.PolyType;
          If (SSLayer = axDrawingAreaPnt.Layer) then
          begin
            If (ShapeListCount = axDrawingAreaPnt.Area) then
            begin
              inc(NumPoints);
              LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
              inc(PointCount);{:=PointCount+NumPoints;}{Total points for File}
              LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[Numparts]:=NumPoints;
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[Numparts].PA,NumPoints+1);
              {CONVERSION to REAL LOCATION}
              REALLOCATIONx:=((axDrawingAreaPnt.X-LowerDigiLocoX) * XScaleRatio)+XOrigin;
              REALLOCATIONy:=((axDrawingAreaPnt.Y-LowerDigiLocoY)* XScaleRatio)+YOrigin;
              If OutUnits then
              begin
                DXdtemp:=REALLOCATIONx;
                DYdtemp:=REALLOCATIONy;
                dXTemp:=DXdtemp*UnitFactorLL;
                dYTemp:=DYdtemp*UnitFactorLL;
                DoLLtoXY( dXTemp,dYTemp,
                         DXdtemp,DYdtemp);
                DXtemp:=ToDDegreeFactorLL*dXdTemp;
                DYtemp:=ToDDegreeFactorLL*dYdTemp;
                REALLOCATIONx:=DXtemp;
                REALLOCATIONy:=DYtemp;
              end;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Xd:=
              REALLOCATIONx ;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Yd:=
              REALLOCATIONy;
              if REALLOCATIONx<dXMINt then dXMINt := REALLOCATIONx;
              if REALLOCATIONx<dXMINtF then dXMINtF := REALLOCATIONx;
              if REALLOCATIONy<dYMINt then dYMINt := REALLOCATIONy;
              if REALLOCATIONy<dYMINtF then dYMINtF := REALLOCATIONy;
              if REALLOCATIONx>dXMAXt then dXMAXt := REALLOCATIONx;
              if REALLOCATIONx>dXMAXtF then dXMAXtF := REALLOCATIONx;
              if REALLOCATIONy>dYMAXt then dYMAXt := REALLOCATIONy;
              if REALLOCATIONy>dYMAXtF then dYMAXtF := REALLOCATIONy;
              LayA[CurrentLayer].LyrShp[ShapeNumber].XMin:= dXMINt;
              LayA[CurrentLayer].LyrShp[ShapeNumber].YMin:= dYMINt;
              LayA[CurrentLayer].LyrShp[ShapeNumber].XMax:= dXMAXt;
              LayA[CurrentLayer].LyrShp[ShapeNumber].YMax:= dYMAXt;
            end else
            begin
              inc(ShapeListCount);
              inc(ShapeNumber);
              {NumShape:=SwapShapeInteger(ICOIn);}{Store total for later}
              Setlength(LayA[CurrentLayer].LyrShp,ShapeNumber+1);
              LayA[CurrentLayer].LyrShp[ShapeNumber].ShpType:=ShapeType;
              LayA[CurrentLayer].LyrShp[ShapeNumber].ShapeIDN:=ShapeNumber;

              LayA[CurrentLayer].LyrShp[ShapeNumber].PartsN:=Numparts;
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PPA,Numparts+1);
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA,Numparts+1);

              NumPoints:=0;
              dXMINt:=1.7 * power(10,308);
              dYMINt:=1.7 * power(10,308);
              dXMAXt:=-1.7 * power(10,308);
              dYMAXt:=-1.7 * power(10,308);
              inc(NumPoints);
              LayA[CurrentLayer].LyrShp[ShapeNumber].PntsN:=NumPoints;
              inc(PointCount);{:=PointCount+NumPoints;}{Total points for File}
              LayA[CurrentLayer].LyrShp[ShapeNumber].PPA[Numparts]:=NumPoints;
              SetLength(LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[Numparts].PA,NumPoints+1);
              {CONVERSION to REAL LOCATION}
              REALLOCATIONx:=((axDrawingAreaPnt.X-LowerDigiLocoX) * XScaleRatio)+XOrigin;
              REALLOCATIONy:=((axDrawingAreaPnt.Y-LowerDigiLocoY)* XScaleRatio)+YOrigin;
              If OutUnits then
              begin
                DXdtemp:=REALLOCATIONx;
                DYdtemp:=REALLOCATIONy;
                dXTemp:=DXdtemp*UnitFactorLL;
                dYTemp:=DYdtemp*UnitFactorLL;
                DoLLtoXY( dXTemp,dYTemp,
                         DXdtemp,DYdtemp);
                DXtemp:=ToDDegreeFactorLL*dXdTemp;
                DYtemp:=ToDDegreeFactorLL*dYdTemp;
                REALLOCATIONx:=DXtemp;
                REALLOCATIONy:=DYtemp;
              end;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Xd:=
              REALLOCATIONx ;
              LayA[CurrentLayer].LyrShp[ShapeNumber].PARA[1{PartNumber}].PA[NumPoints].Yd:=
              REALLOCATIONy;
            end;
          end;
          LayA[CurrentLayer].LayerColor:=
          RGB(Random(255),Random(255),Random(255));
          LayA[CurrentLayer].ShapeN:=ShapeNumber;{NumShape;}
          LayA[CurrentLayer].TotalPnts:=PointCount;
          LayA[CurrentLayer].IslandsN:=0;
          LayA[CurrentLayer].XMin:= dXMINtF;
          LayA[CurrentLayer].YMin:= dYMINtF;
          LayA[CurrentLayer].XMax:= dXMAXtF;
          LayA[CurrentLayer].YMax:= dYMAXtF;
          LayA[CurrentLayer].ZMin:= 0;
          LayA[CurrentLayer].ZMax:= 0;
          LayA[CurrentLayer].MMin:= 0;
          LayA[CurrentLayer].MMax:= 0;
        end;{Areas count}
        If (AttListCount<>ShapeListCount) then
        begin
          DoMessages(204);
          Showmessage(inttostr(AttListCount)+' att<>shp '+inttostr(ShapeListCount));
        end
        else  begin
          ShapeLoaderForm.Show;
          ShapeLoaderForm.SaveShpFile(CurrentLayer,FileName);
          ShapeLoaderForm.Hide;
        end;
      end;{polys}
    End;{Case}
  end else DoMessages(203);
  LayersLoaded:=0;
  SetLength(LayA,0);
  ProgressBar1.Position:=0;
  ShpSaveForm.Hide;
end;
(*******************************************************************)











end.


