unit DOIForm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TDObjectForm = class(TForm)
    Bevel1: TBevel;
    DataNodesEdit: TEdit;
    DataAreasEdit: TEdit;
    DataLinesEdit: TEdit;
    Label31: TLabel;
    Label30: TLabel;
    Label29: TLabel;
    Label32: TLabel;
    OISelection: TSpeedButton;
    OILayersRG: TRadioGroup;
    OINodeEdit: TEdit;
    OIAreaEdit: TEdit;
    OILineEdit: TEdit;
    OIAll: TSpeedButton;
    OILayer: TSpeedButton;
    DeleteSelectionBtn: TSpeedButton;
    HelpBitBtn: TBitBtn;
    Label1: TLabel;
    LinesToAreasBtn: TSpeedButton;
    NewAreaEdit: TEdit;
    LinesToAreasDoneBtn: TSpeedButton;
    DataDLGAreaEdit: TEdit;
    OIDLGAreaEdit: TEdit;
    Label2: TLabel;
    RefreshDLGAreasBtn: TSpeedButton;
    TestDLGBtn: TSpeedButton;
    IslandsUpDown: TUpDown;
    IslandsEdit: TEdit;
    Label3: TLabel;
    procedure HelpBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OILayersRGClick(Sender: TObject);
    procedure OIAllClick(Sender: TObject);
    procedure OILayerClick(Sender: TObject);
    procedure OISelectionClick(Sender: TObject);
    procedure DeleteSelectionBtnClick(Sender: TObject);
    procedure LinesToAreasBtnClick(Sender: TObject);
    procedure LinesToAreasDoneBtnClick(Sender: TObject);
    procedure RefreshDLGAreasBtnClick(Sender: TObject);
    procedure TestDLGBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DObjectForm: TDObjectForm;

implementation

{$R *.DFM}

uses DGlobalsUnit, DigitizerMain, DAttributesForm;

procedure TDObjectForm.FormCreate(Sender: TObject);
begin
  left := DObjectFormX;
  top := DObjectFormY;
end;

procedure TDObjectForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DLGEditing:=False;
  LinesToAreasBtn.Down:=false;
  DObjectFormX := DObjectForm.left;
  DObjectFormY := DObjectForm.top;
  DoSaver;
end;

procedure TDObjectForm.HelpBitBtnClick(Sender: TObject);
begin
  Application.HelpContext(5000);
end;

procedure TDObjectForm.OILayersRGClick(Sender: TObject);
var
Counter,
DataDLGAreaEditCount,
DataNodesEditCount,
DataAreasEditCount,
DataLinesEditCount:Integer;
begin
{Fill the Node, Line, Area values per selected DLG layer item
DataNodesEdit
DataAreasEdit
DataLinesEdit}
DataNodesEditCount:=0;
DataAreasEditCount:=0;
DataLinesEditCount:=0;
DataDLGAreaEditCount:=0;
          if (AttriList.Count > 0) then
          begin
            for Counter := (AttriList.Count - 1) downto 0 do
            begin
              aAttri := AttriList.Items[Counter];
              axAttri.Major := aAttri^.Major;
             If (axAttri.Major = OILayersRG.ItemIndex)
             then
             begin
                axAttri.Count := aAttri^.Count;
                axAttri.ObjectType:= aAttri^.ObjectType;
                If axAttri.ObjectType=0 then
                begin
                If (DataNodesEditCount < axAttri.Count)
                then DataNodesEditCount:= axAttri.Count;
                end else
                If axAttri.ObjectType=1 then
                begin
                If (DataLinesEditCount < axAttri.Count)
                then DataLinesEditCount:= axAttri.Count;
                end else
                If axAttri.ObjectType=2 then
                begin
                If (DataAreasEditCount < axAttri.Count)
                then DataAreasEditCount:= axAttri.Count;
                end else
                If axAttri.ObjectType=3 then
                begin
                If (DataDLGAreaEditCount < axAttri.Count)
                then DataDLGAreaEditCount:= axAttri.Count;
                end;
             end;
           end;
          end;
DataNodesEdit.Text :=Inttostr(DataNodesEditCount);
DataAreasEdit.Text :=Inttostr( DataAreasEditCount);
DataLinesEdit.Text :=Inttostr( DataLinesEditCount);
DataDLGAreaEdit.Text :=Inttostr( DataDLGAreaEditCount);
OINodeEdit.Text:= '0';
OIAreaEdit.Text:= '0';
OILineEdit.Text:= '0';
OIDLGAreaEdit.Text:= '0';
end;


procedure TDObjectForm.OIAllClick(Sender: TObject);
begin
  DigitizerForm2.DVDORedraw;{call normal redraw}
end;

procedure TDObjectForm.OILayerClick(Sender: TObject);
begin
{Set variables DoDrawLayer DoDrawSelection
and call InspectorRedraw}
  If (OILayersRG.ItemIndex > -1) then
     DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,-1,-1)
  else DoMessages(202);
end;

procedure TDObjectForm.OISelectionClick(Sender: TObject);
var DLGItem,Check:Integer;
begin
If (OILayersRG.ItemIndex > -1) then
begin
If OINodeEdit.Text <> '0' then
  begin
  val(OINodeEdit.Text,DLGItem,Check);
  If (Check = 0) then      {(Layered,DLGOType,DLGOItem:Integer)}
  DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,0,DLGItem);
  end else
If OIAreaEdit.Text <> '0' then
  begin
  val(OIAreaEdit.Text,DLGItem,Check);
  If (Check = 0) then
  DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,2,DLGItem);
  end else
If OILineEdit.Text <> '0' then
  begin
  val(OILineEdit.Text,DLGItem,Check);
  If (Check = 0) then
  DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,1,DLGItem);
  end else
If OIDLGAreaEdit.Text <> '0' then
  begin
  val(OIDLGAreaEdit.Text,DLGItem,Check);
  If (Check = 0) then
  DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,3,DLGItem);
  end;
end;
end;


procedure TDObjectForm.DeleteSelectionBtnClick(Sender: TObject);
var LayerCheck,Counter,DLGItem,Check:Integer;
begin  {Delete the Object and its Attribute}
If (OILayersRG.ItemIndex > -1) then
begin

If OINodeEdit.Text <> '0' then
  begin
  val(OINodeEdit.Text,DLGItem,Check);
  If (Check = 0) then
          if (PointList.Count > 0) then
          begin
              dec(CurrentPoint);
              PointList.Delete(DLGItem);
              PointList.Pack;
           end;

          if (AttriList.Count > 0) then
          begin
            for Counter := (AttriList.Count - 1) downto 0 do
            begin
              aAttri := AttriList.Items[Counter];
              axAttri.ObjectType := aAttri^.ObjectType;
              axAttri.Count := aAttri^.Count;
             If ((axAttri.ObjectType = 0) and
                 (axAttri.Count = DLGItem))
             then
             begin
             dec(CurrentAtt);
             AttriList.Delete(Counter);
             AttriList.Pack;
             end;
            end;
          end;
  end else

If OIAreaEdit.Text <> '0' then
  begin
  val(OIAreaEdit.Text,DLGItem,Check);
  If (Check = 0) then
    begin
          if (AreaList.Count > 0) then
          begin
            for Counter := (AreaList.Count - 1) downto 0 do
            begin
              aDrawingAreaPnt := AreaList.Items[Counter];
              axDrawingAreaPnt.Area := aDrawingAreaPnt^.Area;
             If ((axDrawingAreaPnt.Area = DLGItem))
             then
             begin
              dec(CurrentArea);
              AreaList.Delete(Counter);
              AreaList.Pack;
             end;
            end;
           end;
          if (AttriList.Count > 0) then
          begin
            for Counter := (AttriList.Count - 1) downto 0 do
            begin
              aAttri := AttriList.Items[Counter];
              axAttri.ObjectType := aAttri^.ObjectType;
              axAttri.Count := aAttri^.Count;
             If ((axAttri.ObjectType = 2) and
                 (axAttri.Count = DLGItem))
             then
             begin
             AttriList.Delete(Counter);
             dec(CurrentAtt);
             AttriList.Pack;
             end;
            end;
          end;
     end;
  end else

If OILineEdit.Text <> '0' then
  begin
  val(OILineEdit.Text,DLGItem,Check);
  If (Check = 0) then
  begin
          if (LineList.Count > 0) then
          begin
            for Counter := (LineList.Count - 1) downto 0 do
            begin
              aDrawingLnPnt := LineList.Items[Counter];
              axDrawingLnPnt.Line := aDrawingLnPnt^.Line;
             If ((axDrawingLnPnt.Line =DLGItem))
             then
               begin
                dec(CurrentLine);
                LineList.Delete(Counter);
                LineList.Pack;
               end;
            end;
          end;

          if (AttriList.Count > 0) then
          begin
            for Counter := (AttriList.Count - 1) downto 0 do
            begin
              aAttri := AttriList.Items[Counter];
              axAttri.ObjectType := aAttri^.ObjectType;
              axAttri.Count := aAttri^.Count;
             If ((axAttri.ObjectType = 1) and
                 (axAttri.Count = DLGItem))
             then
             begin
               AttriList.Delete(Counter);
               dec(CurrentAtt);
               AttriList.Pack;
             end;
            end;
          end;
   end;
  end else

If OIDLGAreaEdit.Text <> '0' then
  begin
  val(OILineEdit.Text,DLGItem,Check);
  If (Check = 0) then
   begin
    LayerCheck:= OILayersRG.ItemIndex;
          if (DLGAreaList.Count > 0) then
          begin
            for Counter := (DLGAreaList.Count - 1) downto 0 do
            begin
              aDrawingDLGArea := DLGAreaList.Items[Counter];
              axDrawingDLGArea.Area := aDrawingDLGArea^.Area;
             If ((axDrawingDLGArea.Layer =LayerCheck) and
                 (axDrawingDLGArea.Area =DLGItem))
             then
               begin
                dec(CurrentDLGArea);
                DLGAreaList.Delete(Counter);
                DLGAreaList.Pack;
               end;
            end;
          end;
          if (AttriList.Count > 0) then
          begin
            for Counter := (AttriList.Count - 1) downto 0 do
            begin
              aAttri := AttriList.Items[Counter];
              axAttri.ObjectType := aAttri^.ObjectType;
              axAttri.Count := aAttri^.Count;
             If ((axAttri.ObjectType = 3) and
                 (axAttri.Count = DLGItem))
             then
             begin
               AttriList.Delete(Counter);
               dec(CurrentAtt);
               AttriList.Pack;
             end;
            end;
          end;
   end;
  end;

  end;
end;

procedure TDObjectForm.LinesToAreasBtnClick(Sender: TObject);
  var DLGItem,Check:Integer;
begin
  DLGEditing:= (not DLGEditing);
  If  DLGEditing then
  begin
  LinesToAreasBtn.Down:=true;
  val(NewAreaEdit.Text,DLGItem,Check);
  If (Check = 0) then
  begin
   DLGAreaItem:=DLGItem;
   DLGAreaLayer:=OILayersRG.ItemIndex;
   {Set Polygon Array}
   CurrentDLGAreaPoint:=0;
   SetLength(DlgPoints, CurrentDLGAreaPoint);
{   DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,4,DLGItem);}
  end;
  end else
  begin
  LinesToAreasBtn.Down:=false;
  DLGSetAttribute:=false;
  CurrentDLGAreaPoint:=0;
  SetLength(DlgPoints, CurrentDLGAreaPoint);
  end;
{Activate selected layer and
MOUSE lines to select
Background color .. Selected Color .. other lines color
Collate lines into Area
FILL polygon when completed  to test
Rearrange points of polygon when completed}
end;


procedure TDObjectForm.RefreshDLGAreasBtnClick(Sender: TObject);
  var DLGItem,Check:Integer;
begin
  If DLGEditing then
  begin
   If NewAreaEdit.Text <> '0' then
    begin
    val(NewAreaEdit.Text,DLGItem,Check);
    If (Check = 0) then
    DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,4,DLGItem);
    end;
  end;
end;

procedure TDObjectForm.TestDLGBtnClick(Sender: TObject);
  var DLGItem,Check:Integer;
begin
  If DLGEditing then
  begin
  If NewAreaEdit.Text <> '0' then
  begin
  val(NewAreaEdit.Text,DLGItem,Check);
  If (Check = 0) then
  {Turn it into a Filled Polygon};
  DigitizerForm2.InspectorRedraw(OILayersRG.ItemIndex,5,DLGItem);
  end;
  end;
end;

procedure TDObjectForm.LinesToAreasDoneBtnClick(Sender: TObject);
begin
  If DLGEditing then
  begin
  DLGEditing:=False;
  LinesToAreasBtn.Down:=false;
  CurrentDLGAreaPoint:=0;
   SetLength(DlgPoints, CurrentDLGAreaPoint);
  {Process  Attribute}
  DLGSetAttribute:=true;
  AttributesForm.Show;
  end;
end;


end.
