{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit vrrRemConMessages;

interface

uses SysUtils, Classes, Windows, Graphics, Forms,
     VectorTypes;

type  {RC}
   TViewMode = (vmColor4, vmGray4, vmGray8, vmColor24, vmDefault);

const
   // Messages
   // All numbers are 4-byte integers
   // Strings include a null terminating zero
   //RC Messages   Telnet uses port 23
   MSG_LOGON            = 1;     // Client logs on to the server
                                 // Data = password

   MSG_REFRESH          = 2;     // Client wants the entire screen
                                 // Data = Compressed BMP

   MSG_SCREEN_UPDATE    = 3;     // Server sends client a screen update
                                 // Data = Compressed BMP (to XOR)

   MSG_CLICK            = 4;     // Mouse click (single or double, left or right)
                                 // Data = X, Y, Single (1) / Double (2), Left (1) / Right (2)

   MSG_DRAG             = 5;     // Mouse drag
                                 // Data = Left (1) / Right (2), Num Pts, X/Y/time sets

   MSG_KEYS             = 6;     // Send keystrokes
                                 // Data = KeyCode(s)

   MSG_DIRECTORY        = 7;     // Request a directory
                                 // Data = directory (client -> server)
                                 // Data = File StringList
                                 //(dirs end in "\"),
                                 //Size StringList,
                                 //Date/Time StringList (server -> client)

   MSG_FILE             = 8;     // Request a file
                                 // Data = Filename (client -> server)
                                 // Data = File Contents

   MSG_SEVER_DELAY      = 9;     // Set the amount of time
                                 //    the server should wait
                                 //    before sending back the screen image
                                 // Data = Delay in milliseconds

   MSG_FOCUS_SERVER     = 10;    // To restore & focus the Server Window

   MSG_VIEW_MODE        = 11;    // Set the view mode for the graphics
                                 // Data = View Mode (TViewMode as integer)

   MSG_STAT_MSG         = 12;    // Generic Status Msg
                                 // Data = Status Message (string)

   MSG_COMP_MODE        = 13;    // Screen Compression Mode
                                 // Data = CompMode(TCompressionLevel as integer)

   MSG_PRIORITY_MODE    = 14;    // Server Thread Priority
                                 // Data = Priority (integer)

   MSG_PROCESS_LIST     = 15;    // List of running processes
                                 // Data = Process StringList

   MSG_CLOSE_WIN        = 16;    // Close one of the running processes (gracefully)
                                 // Data = Process Name (actually Window Name)

   MSG_KILL_WIN         = 17;    // Kill one of the running processes (NOT graceful)
                                 // Data = Process Name (actually Window Name)

   MSG_DRIVE_LIST       = 18;    // Get a list of all the Logical Drives
                                 // Data = Drives StringList

   MSG_REMOTE_LAUNCH    = 19;    // Launch (ShellExecute) a remote file (of any type)
                                 // Data = Filename
   MSG_REMOTE_EXIT      = 20;    //Exit Drone from Commander

   //Used for TaskCommander and ViewCommander
   //TaskMIDToStr sets the Msg # to a string... used in ViewCommander
  {Commander..Client to Slave..server Drone Messages}
  C2D_MSG_FirstConnect      = 0; {VR does NOT call-Use}
  C2D_MSG_WantConnection    = 1;
  C2D_MSG_WantDisconnection = 2;
  C2D_MSG_StartSendingData  = 3; //
  C2D_MSG_SendBaseData      = 4; // position, up, direction
  C2D_MSG_Task              = 5;
    C2D_MSG_Script              = 55;
  C2D_MSG_WantProgress      = 6;
  C2D_MSG_Priority          = 7;
  C2D_MSG_Cancel            = 8;
  C2D_MSG_WantUsage         = 9;
// serverDrone to Commander messages
  D2C_MSG_AccountValid      = 10000;
    D2C_MSG_AccountInvalid    = 11000;
  D2C_MSG_Connected         = 10001;
  D2C_MSG_DisConnected      = 10002;
  D2C_MSG_CreatePlayer      = 10003;
  D2C_MSG_ReceiveBaseData   = 10004;  // position, up, direction
  D2C_MSG_Task              = 10005;
    D2C_MSG_Script              = 10500;
  D2C_MSG_Progress          = 10006;
    D2C_MSG_Finished          = 10608;
    D2C_MSG_Error             = 10609;
  D2C_MSG_Priority          = 10007;
  D2C_MSG_Cancel            = 10008;
  D2C_MSG_WantUsage         = 10009;
type
//Seems a lot of repeated data
//MOST only used once,
// Yet will all be transmittted EACH time
  TTaskInfo = record
    {C2D or D2C}
    Msg      : cardinal;
    {xxx.xxx.xxx.xxx Set on Want Connection}
    DroneIP : string[15];
     { 2345 is Default    "  "}
    DronePort : cardinal;
     {Sent in C2D_MSG_WantConnection
      checked in C2D_MSG_FirstConnect.. Account Valid or not}
    Password : string[255];
     {xx.xx.xx.name}
    //ClientID.TASKS Available.TaskID.Name
    Info    : string[29];
    {D2C_MSG_Connected      Drone to use}
    ClientID : cardinal;
    //Tasks Available
    TaskAvailable  : cardinal;
    {Drone Task #, " " }
    TaskIDn  : cardinal;
    {Task Name  NOT the xx.xx.xx. portion
        USED to call Drone functions}
    Name    : string[20];

     {Data to Pass to Drone and maybe back again}
    TaskData1  : Integer;
    {Data to Pass to Drone and maybe back again}
    {Also used for CPU usage S2C_MSG_WantUsage and D2C_MSG_Cancel}
    TaskData2  : Double;
    {Progress, Error and This... confused? ever used ?}
    TaskResult  : Integer;
    //D2C_MSG_Task
    StartTime: TDateTime;
    //D2C_MSG_Connected ..CPUSpeed
    //D2C_MSG_Task :Now
    //..D2C_MSG_Finished  TaskInfoFinishTime
    // ..D2C_MSG_Cancel :Now
    FinishTime: TDateTime;
    {File name to process...
        written as ? file for program to read..
        avoid passing strings to Drone}
    InName    : string[255];
    {Result File name MUST be SET by Called Task
    TaskOutFileName}
    OutName    : string[255];
    //D2C_MSG_Task  D2C_MSG_Progress    TaskProgress
    {(0..99) }
    ProgressID  : cardinal;
     {? Started..Errored..Finished ... TaskResult ?}
    StatusID  : cardinal;
     {Dunno what changes iaw this}
    PriorityID  : cardinal;
    //D2C_MSG_Error    GLOBAL TaskErrorID
    ErrorID  : cardinal;       {-101 -1 ,  is an Error..Progress}
    //D2C_MSG_Error    GLOBAL TaskErrorInfo
    ErrorInfo : string[15];    {Need a .RES full of it}
  end;

  TTaskList = record           //ClientID.TASKS Available.TaskID.Name
    Info0    : string[29];     {xx.xx.xx.name}
  end;

  //VR View data
  TClientInfo = record
    ID      : cardinal;
    Address : string[15];
    Name    : string[20];
    Port      : cardinal;
    Password : string[255];
    Msg      : cardinal;
  end;
  //VR View data
  TClientPosition = record
    ID        : cardinal;
    Position  : TVector3f;
    Direction : TVector3f;
    Up        : TVector3f;
  end;

function MIDToStr(MessageID : integer) : string;

{The rest of these from Ben Ziegler code for RC}
   procedure RCGetScreen(var bmp: TBitmap; ViewMode: TViewMode);
   procedure RCCompressBitmap(bmp: TBitmap; var Data: string);
   procedure RCUnCompressBitmap(const Data: string; bmp: TBitmap);
   function  RCIntToByteStr(Value: integer): string;
   function  RCIsValidMessage(const Msg: string): boolean;
   function  RCCurTime: string;
   function  RCMsgLen(const Msg: string): integer;
   function  RCTrimFirstMsg(var Msg: string): string;
   // Debugging
   procedure RCSaveString(const s, FileName: string);


implementation

uses ZLib;

type
   TRGBCol = record
      Blu, Grn, Red : byte;
   end;
   TRGBArray   = array[0..0] of TRGBCol;
   PRGBArray   = ^TRGBArray;

   TByteArray = array[0..0] of byte;
   PByteArray = ^TByteArray;

// midtostr//
function MIDToStr(MessageID : integer) : string;
begin
  case MessageID of
    C2D_MSG_FirstConnect      : Result := 'c2s : first connect';
    C2D_MSG_WantConnection    : Result := 'c2s : want connection';
    C2D_MSG_WantDisconnection : Result := 'c2s : want disconnection';
    C2D_MSG_StartSendingData  : Result := 'c2s : start sending data';
    C2D_MSG_SendBaseData      : Result := 'c2s : sending base data';
    C2D_MSG_Task              : Result := 'c2s : Task:';

    D2C_MSG_AccountValid      : Result := 's2c : account valid';
    D2C_MSG_AccountInvalid    : Result := 's2c : account invalid';
    D2C_MSG_Connected         : Result := 's2c : connected';
    D2C_MSG_CreatePlayer      : Result := 's2c : create player';
    D2C_MSG_ReceiveBaseData   : Result := 's2c : receiving base data';
    D2C_MSG_Progress          : Result := 's2c : Progress %';
    D2C_MSG_Finished          : Result := 's2c : Finished';
    D2C_MSG_Error             : Result := 's2c : Error';
    else
      Result := '??? : unknown message';
  end;
end;

procedure RCSaveString(const s, FileName: string);
var
   fs : TFileStream;
begin
   fs := TFileStream.Create(FileName, fmCreate);
   fs.Write(s[1], Length(s));
   fs.Free;
end;

function RCGammaConv(Value: double; Gamma: double): double;
begin
   if Value <> 0 then Result := Exp(Ln(Value) / Gamma)
      else Result := 0;
end;

function RCCreateGrayPalette(Num: integer; Gamma: double): HPalette;
var
   lPal  : PLogPalette;
   i     : integer;
begin
   // Add the Grayscale palette
   lPal := AllocMem(sizeof(TLogPalette) + Num * sizeof(TPaletteEntry));
   lPal.palVersion   := $300;
   lPal.palNumEntries := Num;
   for i := 0 to Num-1 do with lPal.palPalEntry[i] do begin
      peRed    := Round(255 * RCGammaConv(i / (Num-1), Gamma));
      peGreen  := Round(255 * RCGammaConv(i / (Num-1), Gamma));
      peBlue   := Round(255 * RCGammaConv(i / (Num-1), Gamma));
      peFlags  := 0;
   end;
   Result := CreatePalette(lPal^);
   FreeMem(lPal);
   Win32Check(longbool(Result));
end;

procedure RCConvertToGray_256(bmp: TBitmap);
var
   gm       : TBitmap;  // Destination grayscale bitmap
   x, y     : integer;
   p1       : PRGBArray;
   p2       : PByteArray;
begin
   bmp.PixelFormat := pf24bit;

   // Convert to Grayscale
   gm := TBitmap.Create;
   gm.PixelFormat := pf8bit;
   gm.Width  := bmp.Width;
   gm.Height := bmp.Height;

   gm.Palette := RCCreateGrayPalette(256, 1.4);

   for y := 0 to bmp.Height-1 do begin
      p1 := bmp.ScanLine[y];
      p2 := gm.ScanLine[y];
      for x := 0 to bmp.Width-1 do with p1^[x] do begin
         p2^[x] := (Red * 3 + Grn * 4 + Blu) div 8;
      end;
   end;

   bmp.Assign(gm);
   gm.Free;
end;

procedure RCConvertToGray_16(bmp: TBitmap);
var
   gm       : TBitmap;  // Destination grayscale bitmap
   x, y     : integer;
   p1       : PRGBArray;
   p2       : PByteArray;
   c        : integer;
begin
   bmp.PixelFormat := pf24bit;

   // Convert to Grayscale
   gm := TBitmap.Create;
   gm.PixelFormat := pf4bit;
   gm.Width  := bmp.Width;
   gm.Height := bmp.Height;

   gm.Palette := RCCreateGrayPalette(16, 1.4);

   for y := 0 to bmp.Height-1 do begin
      p1 := bmp.ScanLine[y];
      p2 := gm.ScanLine[y];
      for x := 0 to bmp.Width-1 do with p1^[x] do begin
         c := (Red * 3 + Grn * 4 + Blu) div (8 * 16);
         if (x and 1) = 1 then begin
            p2^[x div 2] := p2^[x div 2] and (not 15) or c;
         end else begin
            p2^[x div 2] := p2^[x div 2] and (15) or (c shl 4);
         end;
      end;
   end;

   bmp.Assign(gm);
   gm.Free;
end;


procedure RCGetScreen(var bmp: TBitmap; ViewMode: TViewMode);
var
   dc : integer;
   c  : TCanvas;
   R  : TRect;
begin
   bmp := TBitmap.Create;

   dc := GetWindowDC(0);
   try
      c := TCanvas.Create;
      c.Handle := dc;
      R := Rect(0, 0, Screen.Width, Screen.Height);
      bmp.Width := R.Right;
      bmp.Height := R.Bottom;
      bmp.Canvas.CopyRect(R, c, R);
      c.Handle := 0;
      c.Free;
   finally
      ReleaseDC(0, dc);
   end;

   case ViewMode of
      vmColor4    : bmp.PixelFormat := pf4bit;
      vmGray4     : RCConvertToGray_16(bmp);
      vmGray8     : RCConvertToGray_256(bmp);
      vmColor24   : bmp.PixelFormat := pf24bit;
      vmDefault   : bmp.HandleType := bmDIB;
   end;
end;

procedure RCCompressBitmap_Slow(bmp: TBitmap; var Data: string);
var
   ms    : TMemoryStream;
   buf   : pointer;
   size  : integer;
begin
   ms := TMemoryStream.Create;

   bmp.SaveToStream(ms);
   CompressBuf(ms.Memory, ms.Size, buf, size);

   SetLength(Data, size);
   Move(buf^, Data[1], size);
   FreeMem(buf);

   ms.Free;
end;

procedure RCCompressBitmap(bmp: TBitmap; var Data: string);
var
   cs      : TCompressionStream;
   ms      : TMemoryStream;
begin
   ms := TMemoryStream.Create;
   cs := TCompressionStream.Create(clDefault, ms); // clDefault is a LOT faster than clMax

   bmp.SaveToStream(cs);
   cs.Free;

   SetLength(Data, ms.Size);
   Move(ms.Memory^, Data[1], ms.Size);

   ms.Free; 
end;

procedure RCUnCompressBitmap(const Data: string; bmp: TBitmap);
var
   ms    : TMemoryStream;
   buf   : pointer;
   size  : integer;
begin
   try
      DecompressBuf(@Data[1], Length(Data), Length(Data) * 3, buf, size);
   except
      on E: Exception do begin
         E.Message := Format('Error Decompressing Buffer (Len = %d):'#13#10'%s', [Length(Data), e.Message]);
         raise;
      end;
   end;

   ms := TMemoryStream.Create;
   ms.Write(buf^, size);
   FreeMem(buf);
   ms.Position := 0;
   Assert(bmp<>nil);
   bmp.LoadFromStream(ms);

   ms.Free;
end;

function RCIntToByteStr(Value: integer): string;
begin
   SetLength(Result, 4);
   Move(Value, Result[1], sizeof(integer));
end;

function RCIsValidMessage(const Msg: string): boolean;
var
   len : integer;
begin
   Result := False;

   len := Length(Msg);
   if len < 8 then exit;

   if RCMsgLen(Msg) > len then exit;

   Result := True;
end;

function RCMsgLen(const Msg: string): integer;
var
   len, mlen : integer;
begin
   len := Length(Msg);
   Assert(len >= 8);
   If len <7 then ;{Compiler quiet}
   Move(Msg[5], mlen, sizeof(integer));

   Result := mlen + 8;
end;

function RCTrimFirstMsg(var Msg: string): string;
begin
   Result := Copy(Msg, 1, RCMsgLen(Msg));
   Msg := Copy(Msg, RCMsgLen(Msg)+1, Length(Msg));
end;

function RCCurTime: string;
begin
   Result := FormatDateTime('mmm d, yyyy  hh:nn:ss ampm', Now);
end;


end.
